  program
! Written by Jon Waterhouse, May 2006

include ('keycodes.clw')

sz      EQUATE(3)
sz2     EQUATE(sz*sz)
debug   EQUATE(0)
debug_level EQUATE(0)
track_on EQUATE(0)
reverse EQUATE(1)

triplet_type group,type
in short
out short
 end

out_type group,type
id short
v short,dim((sz*sz)-sz)
 end

in_type group,type
id short
v short,dim(sz)
fixpos short,dim(sz)
 end

poss group,type
num_possible short
off_limits BYTE
possibles short,dim(sz2)
 end

  map
   accept_grid(),short
   add_debug(short message,short r,short c,short n,short t,short val,short fp)
   addvalue (short row,short col,short val),short
   add_fixpos (short r,short c,short n, short t,short val,short fp),short
   add_to_row (short row,short col,short val,short fp ),short
   add_to_col (short row,short col,short val,short fp ),short
   add_item (short r,short c,short n,short t,short val,short fp),short
   add_q_item (string addtype,short r,short c,short n,short t,short place)
   add_to_outs(short r,short c,short n,short t,short val),SHORT
   checkgrid(string filltype,short r,short c,short n,short t),SHORT
   check_boxcol(short box),short
   check_boxrow(short box),short
   check_col (short col),short
   check_row (short row),short
   check_grid(short r,short c,short n,short t),short
   check_for_fp(short r,short c,short n,short t,short val),short
   compare_pre_post
   fill_checkgrid(string filltype,short r,short c,short n,short t)
   fill_intersect(),short
   fill_display_grid(),short
   fill_q3(short p_action)
   fix_pos_accept (short r,short c,short n,short t,short j,short val,short fp),short
   fixed_pos_corr_all(),short
   fixed_pos_corr(short r,short c,short n,short t),SHORT
   fill_queues
   friendly_reminder(short r,short c,short n,short t)
   get_box(short r_c),short
   getn(short rc),short
   get_nbr(string row_or_col,short row,short col),short
   grid_setup()
   manage_recursion()
   post_add(short r,short c,short n,short t,short val),SHORT
   prepare_recursion_level(short p_level),short
   rejected_value(short r,short c,short n,short t,SHORT val),SHORT
   rem_q_items (short level)
   run_logic(),short
   save_pre_guess()
   transfer_out(short r,short c,short n,short t,short val),SHORT
   triplet_full (short r,short c,short n,short t),short
   back_up(),SHORT
   vals_left (short r,short c,short n,short t),short
   find_in_v (SHORT[] v_in,SHORT num_items,SHORT val_to_find),BYTE
   fill_outunion(short r,short c,short n,short t,short [] out_union)
 end

check_grid byte,dim(sz*sz,sz)

grid_display short,dim(sz2,sz2)

intersect group(poss),dim(sz2,sz2)
 end

triplets GROUP(triplet_type),dim(sz,sz,sz,2)
 END

in_trips GROUP(in_type),dim(sz,sz,sz,2)
 end

out_trips GROUP(out_type),dim(sz,sz,sz,2)
 END

sav_triplets GROUP(triplet_type),dim(sz,sz,sz,2)
 END

sav_in_trips GROUP(in_type),dim(sz,sz,sz,2)
 end

sav_out_trips GROUP(out_type),dim(sz,sz,sz,2)
 END

groups_to_check QUEUE,pre(grps)
grp_type string(2)
ref short
 END

q1 QUEUE,pre(q)
v short
fixpos short
 end

q2 QUEUE,pre(q2)
v short
 end

q3 QUEUE,pre(q3)
level short
currval short
row short
col short
nof string(10)
 end

r_q queue,pre(rq)   !Queue to keep track of where we are in the recursion
level short
item short
row short
col short
ps GROUP(poss)
  end
 end

items_added QUEUE,pre(it)    !Items added in response to a guess
level short
addtype  string(1)
r short
c   short
n short
t short
place short
 end

actions QUEUE,pre(act)       !Actions taken (for debugging)
line string(120)
end

r_db short
c_db short
q_r short
q_c short
q_n short
q_t short

rv short
current_level short
currval short
loop_counter long

local_hi short
local_lo short

Window WINDOW('Sudoku solver'),AT(,,509,318),IMM,GRAY,MAXIMIZE,DOUBLE,AUTO
       LIST,AT(278,7,101,226),USE(?List3),HVSCROLL,FORMAT('20L(2)|M~Actions~'),FROM(actions)
       LIST,AT(382,7,122,226),USE(?List5),HVSCROLL,FORMAT('20L(2)|M~Level~@N4@20L(2)|M~Value~@n2@20L(2)|M~Row~@n2@20L(2)|M~Col~20L(2)|M~Try' &|
           'ing~'),FROM(q3)
       SPIN(@n1),AT(6,10,25,10),USE(q_r),RANGE(1,0),STEP(1)
       SPIN(@n1),AT(35,10,25,10),USE(q_c),RANGE(1,0)
       SPIN(@n1),AT(64,10,25,10),USE(q_n),RANGE(1,0)
       SPIN(@n1),AT(93,10,25,10),USE(q_t),RANGE(1,2)
       BUTTON('Grid setup'),AT(74,26,44,14),USE(?Grid_Button)
       BUTTON('Accept grid'),AT(126,26,43,14),USE(?User_grid)
       STRING(@n8),AT(5,29,23,10),USE(loop_counter)
       STRING(@n3),AT(5,42),USE(local_lo)
       STRING(@n8),AT(21,42,39,10),USE(local_hi)
       STRING('Level'),AT(61,43),USE(?String2)
       STRING('Row'),AT(87,43),USE(?String4)
       STRING('Col'),AT(108,43),USE(?String5)
       STRING('Item'),AT(125,43),USE(?String6)
       STRING('Value'),AT(147,43),USE(?String7)
       STRING('Currently trying:'),AT(5,52),USE(?String1)
       LIST,AT(181,7,32,42),USE(?List2),FROM(q1)
       LIST,AT(231,7,24,42),USE(?List4),VSCROLL,FROM(q2)
       BUTTON('Run logic'),AT(180,51,37,14),USE(?Run_Button),DISABLE
       BUTTON('Start guessing'),AT(225,51,50,14),USE(?Guess_Button),DISABLE
       STRING(@n3b),AT(61,54,17,10),USE(rq:level)
       STRING(@n2),AT(88,54),USE(r_q:row)
       STRING(@n2),AT(108,54),USE(r_q:col)
       STRING(@n2),AT(126,54),USE(r_q.item)
       STRING(@n2),AT(148,54),USE(currval)
       BUTTON('Compare'),AT(338,246,37,14),USE(?comp_button)
       BUTTON('Display'),AT(125,7,45,14),USE(?Button1)
       BUTTON('Exit'),AT(425,245,37,14),USE(?Exit_Button)
     END
ii short
jj short
rv1 short


f_this_round short
max_cells_to_fill short
recursion_prepared BYTE

Control_ID short
  code
  open(window)
  !Create grid
  loop ii= 1 to sz2
    loop jj=1 to sz2
      Control_ID=create(0,CREATE:Entry)
      SetPosition(Control_ID,-10+15*jj,58+15*ii,12,10)
      Control_ID{PROP:Use}=grid_display[ii,jj]
      Control_ID{PROP:Text}='@n2b'
      unhide(Control_ID)
    end
  end
  loop ii=1 to SZ+1                                         !Put in the grid lines
    Control_ID=create(0,CREATE:Line)
    SetPosition(Control_ID,3,70+SZ*15*(ii-1),15*SZ2,0)
    unhide(Control_ID)
    Control_ID=create(0,CREATE:Line)
    SetPosition(Control_ID,3+SZ*15*(ii-1),70,0,15*SZ2)
    unhide(Control_ID)
  end
  ACCEPT
    CASE KEYCODE()
      of EscKey
      stop
    END
    CASE ACCEPTED()
    OF ?Grid_Button
      grid_setup()
      free(actions)          ! Actions before this point are sort of boring
      display
      enable(?Run_button)
    OF ?User_Grid
      rv=accept_grid()
      free(actions)          
      display
      enable(?Run_button)
    OF ?Run_Button
      Disable(?Run_Button)
      enable(?guess_button)
      !omit('***')
      loop jj= 1 to 4        !We need to examine all groups on the first round
        CASE jj
        OF 1
          grps:grp_type='BR'
        OF 2
          grps:grp_type='BC'
        OF 3
          grps:grp_type='R'
        OF 4
          grps:grp_type='C'
        END
        loop ii= 1 to SZ
          grps:grp_type='BR'
          grps:ref=ii
          add(groups_to_check)
        end
      end
      !***
      rv=run_logic()
      rv=fill_display_grid()
    OF ?Button1
      fill_queues
    OF ?Guess_Button
      save_pre_guess()
      if rv < sz2*sz2
        manage_recursion()
      end
    OF ?Comp_Button
      compare_pre_post
    OF ?Exit_Button
      post(Event:CloseWindow)
    END
  END
  return
! Layout of vectors

!   ROWS                        COLUMNS
!010101|040404|070707       010203|040506|070809
!020202|050505|080808       010203|040506|070809
!030303|060606|090909       010203|040506|070809
!--------------------       --------------------
!101010|131313|161616       101112|131415|161718
!111111|141414|171717       101112|131415|161718
!121212|151515|181818       101112|131415|161718
!--------------------       --------------------
!192021|222324|252627       192021|222324|252627
!202020|232323|262626       192021|222324|252627
!212121|242424|272727       192021|222324|252627
!

manage_recursion procedure
rv2 short
k short
 code
  free(actions)
  local_lo=999
  local_hi=1
  if prepare_recursion_level(1) = -1
    return
  end
  loop
    yield
    loop_counter += 1
    display
    add_debug(16,0,0,0,0,0,0)
    rv2=addvalue(r_q.row,r_q.col,r_q.ps.possibles[r_q.item])
    if rv2 >= 0
      currval =r_q.ps.possibles[r_q.item]
      rv2=run_logic()
      if rv2 >= 0
        rv2 = fixed_pos_corr_all()
      end
    end
    if rv2 < 0                ! Found a problem, need to try another value
      if r_q.level < local_lo then local_lo = r_q.level.
      if r_q.level > local_hi then local_hi = r_q.level.
      if back_up() < 0
        message('Recursion: no solution found')
        break
      end
    else                        !All logic has been run with tested value, run_logic has returned 0
                                !Time to test an additional value
      if prepare_recursion_level(r_q.level + 1  ) = 1
          !message('Preparing recursion: nothing left to find')
          break
      . 
    end
  end  !loop
  if rq:level >0
    message('Recursion: solution found!')
  end
  rv=fill_display_grid()
  display

back_up procedure
  code
  loop
    rem_q_items(rq:level)   ! remove the constraints we just put in
    if r_q.item < r_q.ps.num_possible   ! Still something to try at this level
      r_q.item += 1
      put(r_q)
      fill_q3(2)
      return 0
    else                    ! Need to back up another level
      intersect[r_q.row,r_q.col].off_limits = 0
      r_q.level -= 1
      delete(r_q)
      fill_q3(3)
      if rq:level = 0
        break
      end
      get(r_q,r_q.level)
      get(q3,r_q.level)
    end
  end !loop
  return -1

fill_intersect procedure
i short
j short
k short
num_possible short
c short
r short
n short
t short
fixed BYTE
z byte
rv2 short
vals_added short
out_union short,dim(sz2)
 code
 vals_added=0
 loop i = 1 to sz2
   loop j = 1 to sz2
     loop k = 1 to sz2
       out_union[k]=0
     end
     r = get_box(i)
     c = get_box(j)
     n = getn(i)
     t = 1
     fixed = find_in_v(in_trips[r,c,n,t].fixpos,triplets[r,c,n,t].in,int((j-1)%SZ+1))
     if not fixed
       fill_outunion(r,c,n,t,out_union)
       fill_outunion(r,c,int((j-1)%SZ+1),2,out_union)
       intersect[i,j].num_possible=0                    !Anything not in out_union is fair game for that cell
       loop k = 1 to sz2                                !So write it into intersect
         if out_union[k] <> 1
           intersect[i,j].num_possible += 1
           intersect[i,j].possibles[intersect[i,j].num_possible]=k
         end
       end  ! k loop  
       if intersect[i,j].num_possible = 1              !Only one possible value in this cell
         rv2=addvalue(i,j,intersect[i,j].possibles[1]) !So add it
         if rv2 < 0 then return -1.
         vals_added+=1
         intersect[i,j].num_possible=0
       end
     else
       intersect[i,j].num_possible=0
     end ! not fixed if
   end ! j loop
 end ! i loop
 return vals_added                                    !fill_intersect

fill_outunion procedure(r,c,n,t,out_union)
k short
 code
  loop k = 1 to triplets[r,c,n,t].out              ! OR them with the outs from the column
   out_union[out_trips[r,c,n,t].v[k]]=1
  end

prepare_recursion_level procedure(short p_level)
i short
j short
smallest short
sm_i short
sm_j short
sm_proximity BYTE
found BYTE
proximity BYTE
current_box short
 code
 if r_q.level > 1 then current_box=get_box(r_q.row)*SZ+get_box(r_q.col).
 found = 0
 smallest = SZ2+1
 loop i = 1 to SZ2
   loop j = 1 to SZ2
     if not intersect[i,j].off_limits =1 and intersect[i,j].num_possible > 0
       if r_q.level > 1
         if i = r_q.row then proximity += 1.
         if j = r_q.col then proximity += 1.
         if get_box(i)*SZ+get_box(j)=current_box then proximity+=2.
       end
       if intersect[i,j].num_possible < smallest or (intersect[i,j].num_possible = smallest and proximity >sm_proximity)
         smallest = intersect[i,j].num_possible
         sm_proximity=proximity
         sm_i = i
         sm_j = j
         found = 1
       end
     end
   end ! loop j
 end !loop i
 if not found then return 1.        !No values not fixed with more than one possible value
 r_q.level = p_level
 r_q.item=1
 r_q.ps.num_possible =  intersect[sm_i,sm_j].num_possible
 r_q.row=sm_i
 r_q.col=sm_j
 loop i = 1 to intersect[sm_i,sm_j].num_possible
   if REVERSE 
     r_q.ps.possibles[i]=intersect[sm_i,sm_j].possibles[intersect[sm_i,sm_j].num_possible-i+1]
   else
     r_q.ps.possibles[i]=intersect[sm_i,sm_j].possibles[i]
   end
 end
 add(r_q,r_q.level)
 fill_q3(1)
 intersect[sm_i,sm_j].off_limits=1
 return 0

fill_q3 procedure(p_action)
backlevel short
 code
 q3:level = r_q:level
 q3:row=Rq:row
 q3:col=rq:col
 q3.currval = r_q.ps.possibles[r_q.item]
 q3.nof = r_q.item & ' of ' &  r_q.ps.num_possible
 CASE p_action
 OF 1
   add(q3,-q3.level)
 OF 2
   put(q3)
 OF 3
   backlevel = q3.level-1
   delete(q3)
   q3.level = backlevel
   get(q3,q3.level)
 end
 display(q3)

fill_queues procedure
i short
 code
 free(q1)
 free(q2)
 loop i = 1 to triplets[q_r,q_c,q_n,q_t].in
   q1.v = in_trips[q_r,q_c,q_n,q_t].v[i]
   q1.fixpos = in_trips[q_r,q_c,q_n,q_t].fixpos[i]
   add(q1)
 end
 loop i = 1 to triplets[q_r,q_c,q_n,q_t].out
   q2.v = out_trips[q_r,q_c,q_n,q_t].v[i]
   add(q2)
 end

check_boxrow procedure(short box)
r short
c short
rv2 short
 code
 r = get_box(box)
 c = getn(box)
 rv2 = checkgrid('B',r,c,0,1)
 if rv2 < 0  then add_debug(15,rq:level,box,0,0,0,0).
 return rv2

check_boxcol procedure(short box)
r short
c short
rv2 short
 code
 r = get_box(box)
 c = getn(box)
 rv2 = checkgrid('B',r,c,0,2)
 if rv2 < 0 then add_debug(14,rq:level,box,0,0,0,0).
 return rv2

check_col procedure(short col)
c short
n short
rv2 short
 code
 c = get_box(col)                                             !No r to calculate -- will vary in check
 n = getn(col)
 return checkgrid('C',0,c,n,2)

check_row procedure(short row)
r short
n short
rv2 short
 code
 r = get_box(row)                                              !No c to calculate -- will vary in check
 n = getn(row)
 return checkgrid('R',r,0,n,1)

checkgrid procedure(filltype,r,c,n,t)
 code
 fill_checkgrid(filltype,r,c,n,t)
 return check_grid(r,c,n,t)

fill_checkgrid procedure(filltype,r,c,n,t)
i short
j short
 code
 loop i = 1 to sz2
   loop j = 1 to sz
     check_grid[i,j]=0
 ..
 CASE filltype
 OF 'B'
   loop i = 1 to sz
     loop j = 1 to triplets[r,c,i,t].out
       check_grid[out_trips[r,c,i,t].v[j],i]=1          ! Say the values in the first OUT triplet are {2,6,8}
     end  ! loop                                        ! Then in the 2nd, 6th and 8th rows in the 1st column,
     loop j = 1 to triplets[r,c,i,t].in                 ! we put the value 1
       check_grid[in_trips[r,c,i,t].v[j],i]=SZ+1        ! Say the values in the first IN triplet are {1,7}
     end  !loop                                         ! Then in the 1st row and 7th row, 1st column, we put the value 4
   end    !loop                                         
 OF 'C'
   loop i = 1 to sz
     loop j = 1 to triplets[i,c,n,t].out
       check_grid[out_trips[i,c,n,t].v[j],i]=1          
     end  ! loop                                       
     loop j = 1 to triplets[i,c,n,t].in
       check_grid[in_trips[i,c,n,t].v[j],i]=SZ+1
     end  !loop                                         
   end    !loop                                         
 OF 'R'
   loop i = 1 to sz
     loop j = 1 to triplets[r,i,n,t].out
       check_grid[out_trips[r,i,n,t].v[j],i]=1          
     end  ! loop                                       
     loop j = 1 to triplets[r,i,n,t].in
       check_grid[in_trips[r,i,n,t].v[j],i]=SZ+1
     end  !loop                                         
   end    !loop                                        
 end      ! CASE

check_grid procedure(short r,short c,short n,short t)
rowsum short
i short
j short
rv2 short
retval short
 code
 loop i = 1 to sz2
   rowsum = 0
   loop j = 1 to sz
     rowsum += check_grid[i,j]
   end
   if rowsum >= SZ-1                                !If in this range not enough info to do anything
     case rowsum
       of sz-1                                      !Not allowed in two - must be in other
         loop j = 1 to sz
           if check_grid[i,j] <> 1                  ! This is the row/col where the value is allowed
             if n = 0                               ! Called for a box - could be either rows of columns
               rv2=add_item(r,c,j,t,i,0)
             elsif r = 0                            !Called for a column
               rv2=add_item(j,c,n,t,i,0)
             elsif c = 0                            !Called for a row
               rv2=add_item(r,j,n,t,i,0)
             end ! if
             if rv2 < 0
               add_debug(13,r,c,j,t,i,rv2)
               break                                !Done, so finish loop
             end
           end ! if
           if rv2 < 0 then break.
         end !loop
         if rv2 < 0
           retval = -1
         end
       of (2*sz)                            !Nothing to do: position has been found
       of sz+1 to 2*sz-1                    !Should not encounter this: all conjoint triplets should have been updated to exclude added value
         add_debug(12,r,c,n,t,i,rowsum)
         retval= -4
       else
         add_debug(11,r,c,n,t,i,0)
         retval= -3
     end !CASE
   end
   if retval >= 0
      retval += rv2
   else
      return retval
   end
 end   !LOOP
 return retval

fill_display_grid procedure
rval short
cval short
r  short
c  short
k   short
l    short
m    short
n    short
total_added short
 code
 loop r= 1 to sz                                       !box row
   loop c= 1 to sz                                     !box col
     loop k = 1 to sz                                  !row item
       loop l = 1 to sz                                !col item
         loop m = 1 to triplets[r,c,k,1].in            !within row item
           rval = in_trips[r,c,k,1].v[m]
           loop n = 1 to triplets[r,c,l,2].in          !within col_item
             cval =  in_trips[r,c,l,2].v[n]
             if rval = cval
               grid_display[(r-1)*SZ+k,(c-1)*SZ+l] = cval
               total_added+=1
  .......
  rval = fixed_pos_corr_all()
  return total_added

fixed_pos_corr_all procedure
r   short
c   short
n   short
t   short
k  short
rv2 short
  code
  ! The point of this procedure is if you have say values 1,2,3 in a row triplet
  ! and you know the column positions of two of the values, then the third
  ! value cannot be in either of the two known columns, i.e. it
  ! should be added to the outs for that box column.
  ! So...
  ! We first identify triplets (rows or clumns) where there is at least one fixed value, and more
  ! values than just the fixed value.
  ! (For a row triplet) We find the column of the fixed value, and for all the other values in the
  ! row, we add those values to the disallowed values for the column of the fixed value
  loop r = 1 to sz                          !box row
    loop c = 1 to sz                        !box col
      loop n = 1 to sz                      !item (row or col)
        loop t = 1 to 2                     !row/col indicator
          if fixed_pos_corr(r,c,n,t) < 0 then return -1.
          loop k = 1 to triplets[r,c,n,t].out
            rv2=transfer_out(r,c,n,t,out_trips[r,c,n,t].v[k])
          end
       end ! t loop
     end ! n loop
   end ! c loop
 end ! r loop
 return 0

fixed_pos_corr procedure(r,c,n,t)
     !Correction for triplets with fixed positions
     ! Say we have a row in which we know the columns for two values:
     ! [ ] 1 2, and we have a third value to add to the triplet.
     ! Clearly we know which column this needs to go into: however, this is a special
     ! case - sometimes we only have one fixed value.
     ! The general solution is:
     ! Say our new value is three - since we know three must be in this row, but cannot be in
     ! columns 2 or 3, it just plain cannot be in columns 2 or 3, so we add
     ! all of the non-fixed values in the row to the OUTS of all of the
     ! columns with fixed values. Then next time we check the columns
     ! the remaining column (in the case where there was only one) will
     ! get the value added to it.
i   short
k   short
l short
m short
rval short
cval short
f   short
found   BYTE
rv2 short
num_fixed short
 code
 num_fixed=0
 loop i = 1 to triplets[r,c,n,t].in
   if in_trips[r,c,n,t].fixpos[i] > 0
     num_fixed += 1
   end
 end
 if num_fixed > 0 and triplets[r,c,n,t].in - num_fixed > 0
   loop k = 1 to triplets[r,c,n,t].in                           ! For each item in the triplet
     if in_trips[r,c,n,t].fixpos[k] > 0     
       loop f = 1 to triplets[r,c,n,t].in                       !This adds the other values to the outs for this column
         if f = k or in_trips[r,c,n,t].fixpos[f] > 0 then cycle.
         rv2=add_to_outs(r,c,in_trips[r,c,n,t].fixpos[k],t%2+1,in_trips[r,c,n,t].v[f])
         add_debug(10,r,c,n,t,k,f)
         if rv2 < 0 then return -1.
       end ! f loop
     end ! if                                                   !So go on to next item in the triplet
   end !k loop
 end ! if
 return 0

accept_grid procedure
i short
j short
 code
  loop i = 1 to sz2
    loop j = 1 to sz2
      if grid_display[i,j] <> 0
        rv=addvalue(i,j,grid_display[i,j])
      end
    end
  end
  return 0

addvalue procedure (row,col,val)
rv2 short
 code
 if add_to_row(row,col,val,getn(col)) < 0 then return -1.
 if add_to_col(row,col,val,getn(row)) < 0 then return -1.
 return 0

get_box procedure(rc)
   code
   return int((rc-1)/sz) + 1

getn procedure(rc)
 CODE
 return (rc-1)%SZ + 1

get_nbr procedure(row_or_col,row,col)
temp short
   code
   if row_or_col = 'R'
     temp = row%sz
   else
     temp = col%sz
   end
   if temp = 0 then temp = sz.
   return temp

add_to_outs procedure(r,c,n,t,val)
i  short
rv2 short
 code
 add_debug(9,r,c,n,t,val,0)
 if find_in_v(out_trips[r,c,n,t].v,triplets[r,c,n,t].out,val) then return 1.
 if triplets[r,c,n,t].out >= SZ2 - SZ                   ! e.g. 9 possible minus 3 in values
   return -1                                            ! Trying to add too many outs
 else
   triplets[r,c,n,t].out += 1                           ! if not then add it
   out_trips[r,c,n,t].v[triplets[r,c,n,t].out] = val
   add_q_item('O',r,c,n,t,triplets[r,c,n,t].out)        ! to remove on back-tracking
   friendly_reminder(r,c,n,t)
   if transfer_out(r,c,n,t,val) < 0 then return -1.
   add_debug(8,r,c,n,t,val,0)
   if vals_left(r,c,n,t) < 0  then return -1.
 end
 return 0

friendly_reminder procedure(short r,short c,short n,short t)
 code
 if t = 1                                               !Rows
   grps:grp_type='BR'
   grps:ref=(r-1)*SZ+c
   add(groups_to_check)                                 !Mark this box for checking the rows
   grps:grp_type='R'
   grps:ref=(r-1)*SZ+n
   add(groups_to_check)                                 !And this row
 else                                                   !Cols
   grps:grp_type='BC'
   grps:ref=(r-1)*SZ+c
   add(groups_to_check)                                 !Mark this box for checking the cols
   grps:grp_type='C'
   grps:ref=(c-1)*SZ+n
   add(groups_to_check)                                 !and this column
 end

vals_left procedure(r,c,n,t)
only_in_vals short,dim(SZ)
i short
j short
k short
found BYTE
rv2 short
 code
 if triplets[r,c,n,t].in < SZ                           ! Room left in IN
   if triplets[r,c,n,t].out = SZ2-SZ                    ! All OUTS used up
     loop i = 1 to SZ2                                  ! For all allowable values
       found =  find_in_v(out_trips[r,c,n,t].v,triplets[r,c,n,t].out,i)
       if not found then
         found = find_in_v(in_trips[r,c,n,t].v,triplets[r,c,n,t].in,i)
         if not found                                   !If in neither, then add to INs
           rv2 = add_item(r,c,n,t,i,0)
           if rv2 < 0 then return rv2.
         end
       end
     end  ! i loop
   end ! if
 end ! if
 return rv2

find_in_v procedure(v_in,num_items,val_to_find)
j short
 code
 loop j = 1 to num_items      
   if v_in[j]=val_to_find then return 1.
 end
 return 0

transfer_out procedure(r,c,n,t,val)
unfree_cols byte,dim(SZ)
exclude_from byte,dim(SZ)
num_excluded short
one_fixed byte
no_good_cols short
i short
j short
rv2 short
 code
 !The purpose of this procedure is to transfer outlawed
 !values from one dimension to the other.
 !Say you have in a row 1 2 [ ], and you have just determined
 ! that the value 3 cannot go in the third column in that box
 !We need to add the value 3 to the outs for this row
 !If that is the only column free on the row, then
 !it's not too complicated. If there are two free, then
 !we still need to transfer the OUT if the value is outlawed in
 !both columns.
 !The positions excluded in the row(col) are: those that have something
 !fixed in them (which is not the value)
 !or those that are out because the column(row) excludes them
 !If all are out then the value is added to the outs for the row (col)
 exclude_from[n]=1
 loop i = 1 to sz                                           !Documentation based on the original t=1 (a row)
   if i = n then cycle.                                     !This part collects all the rows that outlaw this value
   if find_in_v(out_trips[r,c,i,t].v,triplets[r,c,i,t].out,val) then exclude_from[i]=1.
 end
 loop i = 1 to sz                                           !For each column we now need to find out which
   loop j = 1 to sz                                         !cells this value would be excluded from
     unfree_cols[j]=0                                       !First blank the array
   end                                          
   loop j = 1 to triplets[r,c,i,t%2+1].in                
     if in_trips[r,c,i,t%2+1].fixpos[j] <> 0 and in_trips[r,c,i,t%2+1].v[j] <> val
       unfree_cols[in_trips[r,c,i,t%2+1].fixpos[j]]=1       !If fixed, and not the value we are examining
     end
   end
   no_good_cols=0
   loop j = 1 to sz
      if unfree_cols[j]=1 or exclude_from[j]=1 then no_good_cols += 1. !Cell can be eliminated for either reason
   end                                                       !(used for another fixed value, or row triplet
   if no_good_cols = sz                                      !does not allow it)
      if add_to_outs(r,c,i,t%2+1,val)  < 0 then return -1.   !We add to outs only if all cells in the
   end                                                       !column are eliminated
 end
 return 0

add_to_row procedure(row,col,val,fp)
r short
c short
n short
t short
rv2 short
 code
 r = get_box(row)
 c = get_box(col)
 n = get_nbr('R',row,col)
 t = 1
 return add_item(r,c,n,t,val,fp)

add_to_col procedure(row,col,val,fp)
rv3 short
r short
c short
n short
t short
 code
 r = get_box(row)
 c = get_box(col)
 n = get_nbr('C',row,col)
 t = 2
 return add_item(r,c,n,t,val,fp)

add_item procedure(r,c,n,t,val,fp)
rv3 short
j  short
z short
temp short
nextpos short
 code
 rv3= add_fixpos(r,c,n,t,val,fp)                              ! First assume we are just adding a fixpos
 if rv3 < 0 then                                              ! to an existing value in a triplet
   add_debug(1,r,c,n,t,val,fp)
   return rv3                                                 ! Failed - abort
 elsif rv3 = 0                                                ! Was a real add - continue
   if triplets[r,c,n,t].in >= sz then                         ! No room left in triplet - abort
     add_debug(2,r,c,n,t,val,fp)
     return -9
   .
   if rejected_value(r,c,n,t,val) then                        ! Value is impossible for triplet - abort
     add_debug(3,r,c,n,t,val,fp)
     return -8
   .
   nextpos =  triplets[r,c,n,t].in + 1                        ! Prepare to add value, but don't add till later
   if fp > 0                                                  ! If adding an item in a fixed position
     if fix_pos_accept(r,c,n,t,nextpos,val,fp)=1              ! Check to make sure it can go there
       in_trips[r,c,n,t].fixpos[nextpos]=fp
       add_q_item('X',r,c,n,t,nextpos)
     else
       add_debug(4,r,c,n,t,val,fp)                            ! if not, then abort
       return -6                                              ! Adding item caused a fixpos conflict
     end
   else
     temp= check_for_fp(r,c,n,t%2+1,val)                      ! If we're adding to a column, then check rows and vice versa
     if temp > 0                                              ! A matching value was found in a cross-triplet
       in_trips[r,c,n,t].fixpos[nextpos]=temp                 ! So add the fixpos value
       add_q_item('X',r,c,n,t,nextpos)                        ! For recursion
       loop j = 1 to triplets[r,c,temp,t%2+1].in              ! And try to add the fixpos value to the cross-triplet too
         if in_trips[r,c,temp,t%2+1].v[j]=val
           if fix_pos_accept(r,c,temp,t%2+1,j,val,n)=1        ! Check to make sure this is legal
             in_trips[r,c,temp,t%2+1].fixpos[j]=n
             add_q_item('X',r,c,temp,t%2+1,j)                
           else
             add_debug(5,r,c,n,t,val,fp)                      ! If not then abort
             return -5
           end
         end
       end
     elsif temp < 0
       add_debug(6,r,c,n,t,val,fp)
       return -7                                              ! Adding item caused a fixpos conflict
     end
   end
   triplets[r,c,n,t].in =nextpos
   in_trips[r,c,n,t].v[nextpos]=val                           ! Value addition now after fixpos check
   add_q_item('I',r,c,n,t,nextpos)                            ! For recursion
 end
 if nextpos >= SZ then rv1=triplet_full(r,c,n,t).             ! Should only ever be equal - cascade constraints
 if fixed_pos_corr(r,c,n,t) < 0 then return -1.               ! based on full triplet and new fixpos values
 add_debug(7,r,c,n,t,val,fp)
 if post_add(r,c,n,t,val) < 0                                 ! And cascade some more constraints
   return -1
 end
 return 1

post_add procedure(r,c,n,t,val)
j short
 code
 loop j = 1 to sz                                       !Mark value as unavailable in other rows in box
   if j = n then cycle.                                 !(different nbr in same box)
   if add_to_outs(r,c,j,t,val) < 0 then return -1.
 end !loop
 if t = 1     !rows
   loop j = 1 to sz                                     !Mark value as unavailable in triplets on same row
     if j = c then cycle.                               
     if add_to_outs(r,j,n,t,val) < 0 then return -1.    !for other triplets in this row (different box col)
   end
 else         !cols
   loop j = 1 to sz                                     !Mark value as unavailable in triplets in same col
     if j = r then cycle.
     if add_to_outs(j,c,n,t,val) < 0 then return -1.    !for other triplets in this col (different box row)
   end
 end
 return 0

add_fixpos procedure(short r,short c,short n, short t,short val,short fp)
j short
rv2 short
 code
 if fp > 0                 !Sometimes may get passed something we already have - just need to fix the position
   loop j = 1 to triplets[r,c,n,t].in
     if in_trips[r,c,n,t].v[j]=val
       if fix_pos_accept(r,c,n,t,j,val,fp) = 1
         in_trips[r,c,n,t].fixpos[j]=fp
         add_q_item('X',r,c,n,t,j)
         return 1
       else
         return -1
       end
     end
   end
 end
 return 0                  !Either no fp was specified, or the value is not already in in_trips

fix_pos_accept procedure(r,c,n,t,j,val,fp)
i short
  code
  if in_trips[r,c,n,t].fixpos[j]=fp 
    return 1                                            !Same value is already there
  elsif in_trips[r,c,n,t].fixpos[j]<>0
    return -1                                            !This value is already fixed in another position
  else
    loop i = 1 to SZ
      if in_trips[r,c,n,t].fixpos[i]=fp
        return -1                                        !If anything else is already using that position then error
      end
    end
  end
  return 1

add_q_item procedure(addtype,r,c,n,t,place)
 code
 it:level = rq:level
 it:addtype = addtype
 it:r = r
 it:c = c
 it:n = n
 it:t = t
 it:place = place
 add(items_added)

rem_q_items procedure(level)
count_removed_ins short
count_removed_outs short
 code
 count_removed_Ins=0
 count_removed_outs=0
 loop
   get(items_added,records(items_added))
   if it:level <> level or error() then break.
   if it:addtype = 'I'
     in_trips[it:r,it:c,it:n,it:t].fixpos[triplets[it:r,it:c,it:n,it:t].in] = 0
     triplets[it:r,it:c,it:n,it:t].in -= 1
     count_removed_ins +=1
   elsif it:addtype = 'O'
     triplets[it:r,it:c,it:n,it:t].out -= 1
     count_removed_outs+=1
   elsif it:addtype='X'
     in_trips[it:r,it:c,it:n,it:t].fixpos[it:place] = 0
   end
   delete(items_added)
 end
 add_debug(17,level,count_removed_ins,count_removed_outs,0,0,0)

check_for_fp  procedure(r,c,n,t,val)                    !Checks to see if rows and columns have an intersecting value
i short
j short
temp_fp short
found BYTE
 code
 loop i = 1 to sz
   if find_in_v(in_trips[r,c,i,t].v,triplets[r,c,i,t].in,val)
     temp_fp=i
     loop j = 1 to triplets[r,c,n,t%2+1].in
       if in_trips[r,c,n,t%2+1].fixpos[j] = temp_fp       !This position already used
         return -1
       end
     end
     return temp_fp                                       !If not found then return 0
   end
 end
 return 0

triplet_full procedure(short r,short c,short n,short t)
   !Does two things if the triplet is full:
   !If two of the values are fixed and the other is not, then it puts in 
   !the fixed position of the one that is not fixed
   !2. Makes sure that all of the values not in the triplet are added to the Out for the triplet
i short
j short
k short
found byte
RV2 SHORT
filled_cells short,dim(sz)
not_filled short
num_filled short
  code
  !Record the triplet values with fixed positions
  num_filled = 0
  loop i = 1 to sz
    if in_trips[r,c,n,t].fixpos[i]<>0
      filled_cells[in_trips[r,c,n,t].fixpos[i]]=1
      num_filled+=1
    else
      not_filled = i
    end
  end
  !If one cell only has a non-fixed position
  !then set it to the missing value
  if num_filled = sz-1
    loop i = 1 to sz
      if filled_cells[i]=0
        in_trips[r,c,n,t].fixpos[not_filled]=i
        add_q_item('X',r,c,n,t,not_filled)
        rv2=add_item(r,c,i,t%2+1,in_trips[r,c,n,t].v[not_filled],n)
        if rv2 < 0 then return rv2.
      end
    end
  end
  loop i = 1 to sz2
    if find_in_v(in_trips[r,c,n,t].v,triplets[r,c,n,t].in,i)       !Value is an "IN" value, don't add to outs
      break
    elsif not find_in_v(out_trips[r,c,n,t].v,triplets[r,c,n,t].out,i)
      add_debug(18,r,c,n,t,i,0)
      rv2= add_to_outs(r,c,n,t,i)
      if rv2 < 0 then return rv2.
    end
  end ! loop
  return 0

rejected_value procedure (r,c,n,t,val)
i2 short
 code
 if find_in_v(out_trips[r,c,n,t].v,triplets[r,c,n,t].out,val) then return 2.
 if find_in_v(in_trips[r,c,n,t].v,triplets[r,c,n,t].in,val) then return 1.
 return 0

run_logic procedure
FOUND_THIS_ROUND short
i                short
rv2  short
current_recs short
 code
 found_this_round=0
 current_recs = records(groups_to_check)
 loop i = 1 to current_recs
   get(groups_to_check,i)
   CASE grps:grp_type
   OF 'BR'
     rv2 = check_boxrow(grps:ref)
   OF 'BC'
     rv2=check_boxcol(grps:ref)
   of 'C'
     rv2=check_col(grps:ref)
   of 'R'
     rv2=check_row(grps:ref)
   end
   if rv2 >=0
     found_this_round += rv2
   else
     break
   end
 end
 loop i = 1 to current_recs         !Delete all of the queue records we have dealt with (may be some new ones
   get(groups_to_check,1)           !have been added during this process
   delete(groups_to_check)
 end
 if rv2 < 0 then return -1.
 if found_this_round = 0
   rv2=fill_intersect()
   if rv2=0
     return 0
   elsif rv2 < 0
     return rv2
   else
     rv2=run_logic()
   end
 else
   rv2=run_logic()                   !Called recursively until either a 0 (no more changes to implement)
 .                                   !Or a negative (impossible situation) is found

grid_setup procedure
  code
  omit('16x16')
  rv = addvalue(1,1,7)
  rv = addvalue(1,3,8)
  rv = addvalue(1,4,2)
  rv = addvalue(2,4,12)
  rv = addvalue(3,4,11)
  rv = addvalue(1,6,13)
  rv = addvalue(1,7,4)
  rv = addvalue(1,8,14)
  rv = addvalue(4,10,6)
  rv = addvalue(4,11,12)
  rv = addvalue(4,12,4)
  rv = addvalue(2,13,2)
  rv = addvalue(2,15,1)
  rv = addvalue(3,13,14)
  rv = addvalue(3,15,13)
  rv = addvalue(5,1,1)
  rv = addvalue(6,1,10)
  rv = addvalue(7,1,9)
  rv = addvalue(7,4,16)
  rv = addvalue(8,4,4)
  rv = addvalue(5,7,6)
  rv = addvalue(5,8,15)
  rv = addvalue(6,7,14)
  rv = addvalue(6,8,11)
  rv = addvalue(6,11,15)
  rv = addvalue(6,12,3)
  rv = addvalue(8,14,16)
  rv = addvalue(8,15,15)
  rv = addvalue(8,16,11)
  rv = addvalue(9,2,8)
  rv = addvalue(10,2,4)
  rv = addvalue(11,2,16)
  rv = addvalue(11,4,9)
  rv = addvalue(11,6,5)
  rv = addvalue(11,7,10)
  rv = addvalue(12,6,7)
  rv = addvalue(12,7,9)
  rv = addvalue(9,9,5)
  rv = addvalue(9,12,16)
  rv = addvalue(10,9,14)
  rv = addvalue(10,12,11)
  rv = addvalue(10,14,6)
  rv = addvalue(10,15,8)
  rv = addvalue(10,16,3)
  rv = addvalue(14,1,3)
  rv = addvalue(15,1,4)
  rv = addvalue(14,2,11)
  rv = addvalue(15,2,14)
  rv = addvalue(16,2,2)
  rv = addvalue(15,6,3)
  rv = addvalue(15,7,16)
  rv = addvalue(16,6,14)
  rv = addvalue(16,7,11)
  rv = addvalue(14,12,14)
  rv = addvalue(15,12,2)
  rv = addvalue(16,12,12)
  rv = addvalue(16,14,7)
  rv = addvalue(16,15,5)
  rv = addvalue(16,16,16)
  !16x16
  omit('9x9 recursion')
  rv = addvalue(1,7,3)
  rv = addvalue(2,5,2)
  rv = addvalue(2,6,8)
  rv = addvalue(2,8,6)
  rv = addvalue(2,9,9)
  rv = addvalue(3,4,9)
  rv = addvalue(3,8,1)
  rv = addvalue(4,3,9)
  rv = addvalue(4,4,2)
  rv = addvalue(4,8,7)
  rv = addvalue(4,9,8)
  rv = addvalue(5,4,7)
  rv = addvalue(5,6,1)
  rv = addvalue(6,1,8)
  rv = addvalue(6,2,6)
  rv = addvalue(6,6,5)
  rv = addvalue(6,7,4)
  rv = addvalue(7,2,8)
  rv = addvalue(7,6,2)
  rv = addvalue(8,1,1)
  rv = addvalue(8,2,2)
  rv = addvalue(8,4,5)
  rv = addvalue(8,5,6)
  rv = addvalue(9,3,4)
  !9x9 recursion
  omit('9x9 telegram')
  rv = addvalue(1,1,9)
  rv = addvalue(1,2,5)
  rv = addvalue(2,2,6)
  rv = addvalue(2,4,2)
  rv = addvalue(2,5,5)
  rv = addvalue(3,2,3)
  rv = addvalue(3,4,6)
  rv = addvalue(3,7,4)
  rv = addvalue(3,8,5)
  rv = addvalue(4,1,5)
  rv = addvalue(4,7,3)
  rv = addvalue(5,2,2)
  rv = addvalue(5,3,1)
  rv = addvalue(5,7,6)
  rv = addvalue(5,8,4)
  rv = addvalue(6,3,7)
  rv = addvalue(6,9,9)
  rv = addvalue(7,2,4)
  rv = addvalue(7,3,5)
  rv = addvalue(7,6,1)
  rv = addvalue(7,8,9)
  rv = addvalue(8,5,2)
  rv = addvalue(8,6,9)
  rv = addvalue(8,8,7)
  rv = addvalue(9,8,2)
  rv = addvalue(9,9,3)
  !9x9 telegram
  !omit('Recursion 1')
  rv = addvalue(1,3,6)
  rv = addvalue(1,5,4)
  rv = addvalue(1,7,9)
  rv = addvalue(2,1,5)
  rv = addvalue(2,2,4)
  rv = addvalue(2,3,7)
  rv = addvalue(2,5,6)
  rv = addvalue(2,9,3)
  rv = addvalue(3,6,8)
  rv = addvalue(4,2,2)
  rv = addvalue(4,3,9)
  rv = addvalue(4,4,3)
  rv = addvalue(4,8,4)
  rv = addvalue(5,5,2)
  rv = addvalue(6,2,5)
  rv = addvalue(6,6,6)
  rv = addvalue(6,7,7)
  rv = addvalue(6,8,8)
  rv = addvalue(7,4,1)
  rv = addvalue(8,1,6)
  rv = addvalue(8,5,8)
  rv = addvalue(8,7,1)
  rv = addvalue(8,8,7)
  rv = addvalue(8,9,5)
  rv = addvalue(9,3,5)
  rv = addvalue(9,5,7)
  rv = addvalue(9,7,3)
  !Recursion 1
  rv=fill_display_grid()

save_pre_guess procedure
r short
c short
n short
t short
j short
  code
  loop r = 1 to SZ
    loop c = 1 to SZ
      loop n = 1 to SZ
        loop t = 1 to 2
          sav_triplets[r,c,n,t].in = triplets[r,c,n,t].in
          sav_triplets[r,c,n,t].out = triplets[r,c,n,t].out
          loop j = 1 to triplets[r,c,n,t].in
            sav_in_trips[r,c,n,t].v[j]=in_trips[r,c,n,t].v[j]
            sav_in_trips[r,c,n,t].fixpos[j]=in_trips[r,c,n,t].fixpos[j]
          end
          loop j = 1 to triplets[r,c,n,t].out
            sav_out_trips[r,c,n,t].v[j]=out_trips[r,c,n,t].v[j]
          end
        end
      end
    end
  end

compare_pre_post procedure
r short
c short
n short
t short
j short
cat short,dim(5)
  code
  loop r = 1 to SZ
    loop c = 1 to SZ
      loop n = 1 to SZ
        loop t = 1 to 2
          if sav_triplets[r,c,n,t].in <> triplets[r,c,n,t].in then cat[1] += 1.
          if sav_triplets[r,c,n,t].out <> triplets[r,c,n,t].out then cat[2] += 1.
          loop j = 1 to triplets[r,c,n,t].in
            if sav_in_trips[r,c,n,t].v[j]<>in_trips[r,c,n,t].v[j] then cat[3] += 1.
            if sav_in_trips[r,c,n,t].fixpos[j]<> in_trips[r,c,n,t].fixpos[j] then cat[4] += 1.
          end
          loop j = 1 to triplets[r,c,n,t].out
            if sav_out_trips[r,c,n,t].v[j]<>out_trips[r,c,n,t].v[j] then cat[5] += 1.
          end
        end
      end
    end
  end
  message('Discrepancies in IN ' & cat[1] & ' out ' & cat[2] & ' intrips ' & cat[3] & ' fixpos ' & cat[4] & ' outs ' & cat[5])

add_debug procedure(message,r,c,n,t,val,fp)
will_add BYTE
 code
 CASE message
 OF 1
   if debug_level >= 1 then
     will_add=1
     act:line = 'Return for add_item due to add_fixpos error (' & val & ') for ' & r & ',' &c & ','& n & ',' & t & 'fp:' & fp
   .
 OF 2
   if debug_level >= 1 then
     will_add=1
     act:line = 'Rejected new value - already full (' & val & ') for ' & r & ',' &c & ','& n & ',' & t
   .
 OF 3
   if debug_level >= 1 then
     will_add=1
     act:line = 'Rejected new value - is in outs (' & val & ') for ' & r & ',' & c & ','& n & ',' & t
   .
 OF 4
   if debug_level >= 1
     will_add=1
     act:line = 'Rejected new value - fixpos conflict -6 (' & val & ') for ' & r & ',' & c & ','& n & ',' & t
   end
 OF 5
   if debug_level >= 1
     will_add=1
     act:line = 'Rejected new value - fixpos conflict -5 (' & val & ') for ' & r & ',' & c & ','& n & ',' & t
   end
 OF 6
   if debug_level >= 1
     act:line = 'Rejected new value - fixpos conflict -7 (' & val & ') for ' & r & ',' & c & ','& n & ',' & t
     will_add=1
   end
 OF 7
   if debug_level >= 2
     act:line = val &' added to ' & r&',' & c & ',' & n & ',' &  '(' & t &') (pos):' & triplets[r,c,n,t].in
     will_add=1
   end
 OF 8
   if debug_level >= 3
     act:line = 'add_to_outs with '& r &',' & c & ',' & n & ',' & t & ':' & triplets[r,c,n,t].out & '--' & val
     will_add=1
   end
 OF 9
   if dEBUG_level > 3
     act:line = 'add_to_outs with '& r&',' & c & ',' & n & ',' & t & '--' & val
     will_add=1
   .
 OF 10
   if debug_level >= 3
     act:line = 'Fixed pos corr added to outs ' & r&c&in_trips[r,c,n,t].fixpos[val]&t%2+1&':' & in_trips[r,c,n,t].v[fp]
     will_add=1
   end
 OF 11
   if debug_level >= 2
     act:line = 'Impossible:' & R & ',' & c & ',' & n & ',' & t & ':' & val & '(' & check_grid[val,1] & check_grid[val,2] & check_grid[val,3] & ')'
     will_add=1
   end
 OF 12
   if debug_level >= 1
     act:line = 'transfer error? for ' & r & ',' & c & ',' & n & ',' & t & ' value ' & val & ' rowsum is ' & fp
     will_add=1
   end
 OF 13
   if debug_level > 2
     act:line = fp & ' error returned from add_item IN CHECK_GRID, pos ' & r & ',' & c & ',' & n & ',' & t & ' val ' & val
     will_add=1
   end
 OF 14
   if debug_level >= 1
     act:line = 'Check box for level ' & r & ' returned an error for cols in box ' & c
     will_add=1
   end
 OF 15
   if debug_level >= 1
     act:line = 'Check box for level ' & r & ' returned an error for rows in box ' & c
     will_add=1
   end
 OF 16
   if debug_level >= 1
     act:line = 'Level ' & r_q.level & 'Testing ' & r_q.ps.possibles[r_q.item] & ' pos ' & r_q.row & ',' &  r_q.col
     will_add=1
   end
 OF 17
   if debug_level >= 1
     act:line = 'Removed for this level ' & r & ':' & c & ' ins and ' & n & ' outs'
     will_add=1
   end
 OF 18
   if debug_level >= 3 then
     will_add=1
     act:line = val &' added to outs (by full_trip) ' & r&',' & c & ',' & n & ',' &  '(' & t &') (pos):' & triplets[r,c,n,t].in
   .
 END
 if will_add then add(actions).
